/*/////////////////////////////////////////////////////////////// 
 Data Visualization by Echo Theohar for MAT 259
 Processing Version 3.3.5
 Libraries used: OpenCV
 Examples used: LiveCamTest
 All data is sourced from George Legrady and his research with the Centre Pompidou.
 This data is proprietary to the Pompidou and is therefore protected by law. 
 Do not distribute.
 *///////////////////////////////////////////////////////////////

import gab.opencv.*;
import processing.video.*;
import java.awt.*;

Capture video;
OpenCV opencv;

final float margin_to_left = 25;
final float margin_to_top = 100;

Table all_data; 
Table all_data2; 
Table all_data3; 
Table all_data4; 

int  rows, cols;
int rows2, cols2;
int  rows3, cols3;
int rows4, cols4;

float cell_width, cell_height;

float[][] data_matrix;
float[][] data_matrix2;
float[][] data_matrix3;
float[][] data_matrix4;

String[] timestamp;
String[] sessionID;
String[] timestamp2;
String[] sessionID2;
String[] timestamp3;
String[] sessionID3;
String[] timestamp4;
String[] sessionID4;

int index = 0;
int timer = 0;

int Google_count = 0;
int IranianUK_count = 0;
int Iran_count = 0;
int Facebook_count = 0;
int Instagram_count = 0;
int BBC_count = 0;
int Gmail_count = 0;
int Hotmail_count = 0;
int Yahoo_count = 0;
int Youtube_count = 0;
int Senego_count = 0;
int Seneweb_count = 0;
int LeMonde_count = 0;
int LeFigaro_count = 0;
int LeParisien_count = 0;
int AirBNB_count = 0;

String element;

String [] Query = {"google", "iranianuk", "iran", "facebook", "instagram", "bbc", "gmail", "hotmail", "yahoo", "youtube", "senego", "seneweb", "le monde", "le figaro", "le parisien", "airbnb"};

int [] Test = {377, 0, 2, 222, 7, 13, 120, 46, 60, 166, 33, 24, 0, 0, 0, 0}; 
String [] Test2 = {"377", "0", "2", "222", "7", "13", "120", "46", "60", "166", "33", "24", "0", "0", "0", "0"}; 

int [] March = {278, 7, 2, 142, 4, 10, 55, 19, 35, 89, 29, 22, 1, 3, 0, 1}; 
String [] March2 = {"278", "7", "2", "142", "4", "10", "55", "19", "35", "89", "29", "22", "1", "3", "0", "1"}; 

int [] June = {29, 0, 0, 25, 1, 2, 19, 3, 10, 17, 3, 2, 3, 1, 1, 0}; 
String [] June2 = {"29", "0", "0", "25", "1", "2", "19", "3", "10", "17", "3", "2", "3", "1", "1", "0"}; 

int [] August = {70, 0, 0, 55, 2, 1, 46, 24, 15, 60, 1, 0, 2, 4, 2, 1}; 
String [] August2 = {"70", "0", "0", "55", "2", "1", "46", "24", "15", "60", "1", "0", "2", "4", "2", "1"}; 



void setup() {
  size(640, 720);

  //face capture
  video = new Capture(this, 320, 240);
  opencv = new OpenCV(this, 320, 240);
  opencv.loadCascade(OpenCV.CASCADE_FRONTALFACE);  

  video.start();

  //import tables
  all_data = loadTable("FullSearchData.csv", "header");
  all_data2 = loadTable("MarchData.csv", "header");
  all_data3 = loadTable("JuneData.csv", "header");
  all_data4 = loadTable("AugustData.csv", "header");


  //find rows and columns
  rows = all_data.getRowCount ();
  cols = all_data.getColumnCount ();

  rows2 = all_data2.getRowCount ();
  cols2 = all_data2.getColumnCount ();

  rows3 = all_data3.getRowCount ();
  cols3 = all_data3.getColumnCount ();

  rows4 = all_data4.getRowCount ();
  cols4 = all_data4.getColumnCount ();

  //print results

  println("All Rows:"+rows);
  println("All Colums:"+cols);

  println("March Rows:"+rows2);
  println("March Colums:"+cols2);

  println("June Rows:"+rows3);
  println("June Colums:"+cols3);

  println("August Rows:"+rows4);
  println("August Colums:"+cols4);

  ////////////

  cell_width = (width - margin_to_left * 19) / cols;
  cell_height = (height - margin_to_top * 2) / rows;

  //row and column set up

  data_matrix = new float[rows][cols-2];
  sessionID = new String[rows];
  timestamp = new String[rows];

  data_matrix2 = new float[rows2][cols2-2];
  sessionID2 = new String[rows2];
  timestamp2 = new String[rows2];

  data_matrix3 = new float[rows3][cols3-2];
  sessionID3 = new String[rows3];
  timestamp3 = new String[rows3];

  data_matrix4 = new float[rows4][cols4-2];
  sessionID4 = new String[rows4];
  timestamp4 = new String[rows4];

  /////////////// get sessionID and timestamp from each dataset

  for (int i=0; i<rows; i++) {
    for (int j=0; j<cols-2; j++) {
      data_matrix[i][j] = all_data.getFloat(i, j+2);

      // pull ID data from the table to the array
      sessionID[i] = all_data.getString(i, 0);
      timestamp[i] = all_data.getString(i, 1);
    }
  }

  for (int i=0; i<rows2; i++) {
    for (int j=0; j<cols2-2; j++) {
      data_matrix2[i][j] = all_data2.getFloat(i, j+2);

      // pull ID data from the table to the array
      sessionID2[i] = all_data2.getString(i, 0);
      timestamp2[i] = all_data2.getString(i, 1);
    }
  }

  for (int i=0; i<rows3; i++) {
    for (int j=0; j<cols3-2; j++) {
      data_matrix3[i][j] = all_data3.getFloat(i, j+2);

      // pull ID data from the table to the array
      sessionID3[i] = all_data3.getString(i, 0);
      timestamp3[i] = all_data3.getString(i, 1);
    }
  }

  for (int i=0; i<rows4; i++) {
    for (int j=0; j<cols4-2; j++) {
      data_matrix4[i][j] = all_data4.getFloat(i, j+2);

      // pull ID data from the table to the array
      sessionID4[i] = all_data4.getString(i, 0);
      timestamp4[i] = all_data4.getString(i, 1);
    }
  }

  //Searches for query strings in data set (change row and all_data number for 
  //different data sets).

  for (int i = 0; i < rows2; i++) {
    element = all_data2.getString(i, 4);
    if (element.equals("google")) {
      Google_count += 1;
    }
    if (element.equals("iranianuk")) {
      IranianUK_count += 1;
    }
    if (element.equals("iran")) {
      Iran_count += 1;
    }
    if (element.equals("facebook")) {
      Facebook_count += 1;
    }
    if (element.equals("instagram")) {
      Instagram_count += 1;
    }
    if (element.equals("bbc")) {
      BBC_count += 1;
    }
    if (element.equals("gmail")) {
      Gmail_count += 1;
    }
    if (element.equals("hotmail")) {
      Hotmail_count += 1;
    }
    if (element.equals("yahoo")) {
      Yahoo_count += 1;
    }
    if (element.equals("youtube")) {
      Youtube_count += 1;
    }
    if (element.equals("senego")) {
      Senego_count += 1;
    }
    if (element.equals("seneweb")) {
      Seneweb_count += 1;
    }
    if (element.equals("le monde")) {
      LeMonde_count += 1;
    }
    if (element.equals("le figaro")) {
      LeFigaro_count += 1;
    }
    if (element.equals("le parisien")) {
      LeParisien_count += 1;
    }
    if (element.equals("airbnb")) {
      AirBNB_count += 1;
    }
  }
  println("google:"+ Google_count);
  println("iranianuk:"+ IranianUK_count);
  println("iran:"+ Iran_count);
  println("facebook:"+ Facebook_count);
  println("instagram:"+ Instagram_count);
  println("bbc:"+ BBC_count);
  println("gmail:"+ Gmail_count);
  println("hotmail:"+ Hotmail_count);
  println("yahoo:"+ Yahoo_count);
  println("youtube:"+ Youtube_count);
  println("senego:"+ Senego_count);
  println("seneweb:"+ Seneweb_count);
  println("le monde:"+ LeMonde_count);
  println("le figaro:"+ LeFigaro_count);
  println("le parisien:"+ LeParisien_count);
  println("airbnb:"+ AirBNB_count);
}

void draw() {
  scale(2);
  opencv.loadImage(video);
  background(0);

  image(video, 0, 0 );

  //face capture settings
  noFill();
  stroke(0, 0, 255);
  strokeWeight(1);
  ellipseMode(CORNER);
  Rectangle[] faces = opencv.detect();


  // draw face capture
  for (int i = 0; i < faces.length; i++) {
    println(faces[i].x + "," + faces[i].y);
    ellipse(faces[i].x, faces[i].y, faces[i].width, faces[i].height);
    if (timer % 6 == 0) {
      if ((faces[i].x < 80)) { //4 because the screen is too small
        index += 1;
      } else {
        if (index == 0) index = 0;
        else index -= 1;
      }
    }
    //draw face text
    pushMatrix();
    translate(-30, 0);
    textSize(7);
    textAlign(LEFT);
    String ID = "SessionID:\n";
    String ID2 = sessionID2[index];
    text(ID+ID2, faces[i].x, faces[i].y);
    popMatrix();

    pushMatrix();
    translate(-30, 40);
    String time = "Timestamp:\n";
    String time2 = timestamp2[index];
    text(time+time2, faces[i].x, faces[i].y);
    popMatrix();
  }

  //slow down anim
  timer += 1;


  //draw query text
  for (int i = 0; i < Query.length; i++) {
    fill(255);
    textSize(7);
    pushMatrix();
    textAlign(RIGHT);
    translate(50, 330);
    rotate(PI/-2);
    text(Query[i], 20, 15*i);
    popMatrix();
  }

  //draw instructional text

  pushMatrix();
  textSize(8);
  text("Move right to decrease time.\nMove left to increase time.", 300, 205);
  popMatrix();
  
  /////////////
    //println(timeParser(timestamp[i]));
   
    int random_num = int(random(0,3));

  /////time parser

    if (random_num == 0) {

      //draw bar graphs (change string for different datasets)
      for (int i = 0; i <March.length; i++) { 
        stroke (255);
        int multiplier = -1;
        pushMatrix();
        translate(45, 130);
        rect ((15 * i), 160, 10, (March[i]*multiplier)/2 );
        popMatrix();
      }

      //draw bar graph nums (change string for different datasets)
      for (int i = 0; i < March2.length; i++) {
        fill(255);
        textSize(5);
        pushMatrix();
        translate(52, -40);
        text(March2[i], 15*i, 340);
        popMatrix();
        textSize(10);
        text("March", 50, 350);
      }
    } else if (random_num == 1) {

      //draw bar graphs (change string for different datasets)
      for (int i = 0; i <June.length; i++) { 
        stroke (255);
        int multiplier = -1;
        pushMatrix();
        translate(45, 130);
        rect ((15 * i), 160, 10, (June[i]*multiplier)/2 );
        popMatrix();
      }

      //draw bar graph nums (change string for different datasets)
      for (int i = 0; i < June2.length; i++) {
        fill(255);
        textSize(5);
        pushMatrix();
        translate(52, -40);
        text(June2[i], 15*i, 340);
        popMatrix();
        textSize(10);
        text("June", 50, 350);
      }
    } else if (random_num == 2) {
      //draw bar graphs (change string for different datasets)
      for (int i = 0; i <August.length; i++) { 
        stroke (255);
        int multiplier = -1;
        pushMatrix();
        translate(45, 130);
        rect ((15 * i), 160, 10, (August[i]*multiplier)/2 );
        popMatrix();
      }

      //draw bar graph nums (change string for different datasets)
      for (int i = 0; i < August2.length; i++) {
        fill(255);
        textSize(5);
        pushMatrix();
        translate(52, -40);
        text(August2[i], 15*i, 340);
        popMatrix();
        textSize(10);
        text("August", 50, 350);
      }
    }
  
}

void captureEvent(Capture c) {
  c.read();
}